Index: build.linux32ARM/squeak.cog.spur/plugins.ext
===================================================================
--- build.linux32ARM/squeak.cog.spur/plugins.ext	(revision 3663)
+++ build.linux32ARM/squeak.cog.spur/plugins.ext	(working copy)
@@ -2,8 +2,8 @@
 EXTERNAL_PLUGINS = \
 #B3DAcceleratorPlugin \
 #Squeak3D \
-#BochsIA32Plugin \
 #GdbARMPlugin \
+ImmX11Plugin \
 SqueakFFIPrims \
 SqueakSSL \
 LocalePlugin \
Index: platforms/unix/vm-display-X11/sqUnixX11.c
===================================================================
--- platforms/unix/vm-display-X11/sqUnixX11.c	(revision 3663)
+++ platforms/unix/vm-display-X11/sqUnixX11.c	(working copy)
@@ -1711,8 +1711,70 @@
   Answer 1 if some keys are still pending.
 */
 
+#if 1
 static int recordPendingKeys(void)
 {
+  if (inputCount <= 0) {
+    if (inputBuf != inputString) {
+      free(inputBuf);
+      inputBuf= inputString;
+    }
+    return 0;
+  }
+
+  int utf32 = 0;
+  while (inputCount > 0) {
+    //110x xxxx 10xx xxxx
+    if (inputCount >= 2 &&
+	pendingKey[0] >= 0xc0 && pendingKey[0] <= 0xdf && 
+	pendingKey[1] >= 0x80 && pendingKey[1] <= 0xbf) {
+
+      utf32 = ((pendingKey[0] & 0x1f) << 6) |
+              (pendingKey[1] & 0x3f);
+      recordKeyboardEvent(0, EventKeyDown, modifierState, utf32);
+      recordKeyboardEvent(0, EventKeyChar, modifierState, utf32);
+      pendingKey += 2;
+      inputCount -= 2;
+      //1110 xxxx 10xx xxxx 10xx xxxx
+    } else if (inputCount >= 3 &&
+	      pendingKey[0] >= 0xe0 && pendingKey[0] <= 0xef && 
+	      pendingKey[1] >= 0x80 && pendingKey[1] <= 0xbf && 
+	       pendingKey[2] >= 0x80 && pendingKey[2] <= 0xbf) {
+      utf32 = ((pendingKey[0]  & 0x0f) << 12) | 
+	      ((pendingKey[1] & 0x3f) << 6) | 
+	      (pendingKey[2] & 0x3f);
+      recordKeyboardEvent(0, EventKeyDown, modifierState, utf32);
+      recordKeyboardEvent(0, EventKeyChar, modifierState, utf32);
+      pendingKey += 3;
+      inputCount -= 3;
+      //1111 0xxx 10xx xxxx 10xx xxxx 10xx xxxx
+    } else if (inputCount >= 4 &&
+	       pendingKey[0] >= 0xf0 && pendingKey[0] <= 0xf7 && 
+	       pendingKey[1] >= 0x80 && pendingKey[1] <= 0xbf && 
+	       pendingKey[2] >= 0x80 && pendingKey[2] <= 0xbf && 
+	       pendingKey[3] >= 0x80 && pendingKey[3] <= 0xbf) {
+      utf32 = ((pendingKey[0] & 0x07) << 18) | 
+	      ((pendingKey[1] & 0x3f) << 12) |
+	      ((pendingKey[2] & 0x3f) << 6) |
+	      (pendingKey[3] & 0x3f);
+      recordKeyboardEvent(0, EventKeyDown, modifierState, utf32);
+      recordKeyboardEvent(0, EventKeyChar, modifierState, utf32);
+      pendingKey += 4;
+      inputCount -= 4;
+    } else {
+      recordKeyboardEvent(*pendingKey, EventKeyDown, modifierState, 0);
+      recordKeyboardEvent(*pendingKey, EventKeyChar, modifierState, 0);
+      recordKeystroke(*pendingKey); /* DEPRECATED */
+      pendingKey++;
+      inputCount--;
+    }
+  }
+  return 0;
+}
+
+#else
+static int recordPendingKeys(void)
+{
   if (inputCount > 0)
     {
       int i= iebOut - iebIn;
@@ -1738,6 +1800,8 @@
   return 0;
 }
 
+#endif
+
 static int xkeysym2ucs4(KeySym keysym);
 
 static int x2sqKeyInput(XKeyEvent *xevt, KeySym *symbolic)
